diff -Naur -X diff_ignore rsync-3.0.6_base/match.c rsync/match.c
--- rsync-3.0.6_base/match.c	2010-10-25 14:18:07.000000000 -0400
+++ rsync/match.c	2018-05-21 13:20:01.000000000 -0400
@@ -26,6 +26,8 @@
 extern int checksum_seed;
 extern int append_mode;
 extern int checksum_len;
+extern int dont_csum_data_buffer;
+extern int rcvr_is_non_local_server;
 
 int updating_basis_file;
 char sender_file_sum[MAX_DIGEST_LEN];
@@ -41,6 +43,15 @@
 
 extern struct stats stats;
 
+// BOMBICH
+struct timeval last_update_match;
+static unsigned long msdiff(struct timeval *t1, struct timeval *t2)
+{
+	return (t2->tv_sec - t1->tv_sec) * 1000L
+		+ (t2->tv_usec - t1->tv_usec) / 1000;
+}
+
+
 #define TRADITIONAL_TABLESIZE (1<<16)
 
 static uint32 tablesize;
@@ -125,9 +136,11 @@
 		n += s->sums[i].len;
 	}
 
-	for (j = 0; j < n; j += CHUNK_SIZE) {
-		int32 n1 = MIN(CHUNK_SIZE, n - j);
-		sum_update(map_ptr(buf, last_match + j, n1), n1);
+	if (dont_csum_data_buffer == 0) {
+		for (j = 0; j < n; j += CHUNK_SIZE) {
+			int32 n1 = MIN(CHUNK_SIZE, n - j);
+			sum_update(map_ptr(buf, last_match + j, n1), n1);
+		}
 	}
 
 	if (i >= 0)
@@ -137,6 +150,29 @@
 
 	if (buf && do_progress)
 		show_progress(last_match, buf->file_size);
+
+// BOMBICH
+#ifdef PARSEABLE_OUTPUT
+	// This provides updates when we're in the middle of copying a single file (sender)
+	if (buf && rcvr_is_non_local_server) {
+		struct timeval now;
+		gettimeofday(&now, NULL);
+		unsigned long time_diff = msdiff(&last_update_match, &now);
+		if (time_diff > 1000 && offset < buf->file_size) {
+			// sender.c provides updates that include a filename, so don't post an update here if
+			// we've reached EOF. If we had a read error, though, make sure sender updates on the very next file
+			if (buf->status != 0)
+				last_update_match.tv_sec = 0;
+			else
+				last_update_match = now;
+
+			// Presumptively report total_transferred_size + offset as long as we don't have a read error
+			//rprintf(FINFO, "S;;;STATS;;;TTS;;;%lld;;;PROG;;;%d\n", tts, ((100 * tts) / stats.total_size));
+			int64 tts = stats.total_transferred_size + (buf->status == 0 ? offset : 0);
+			rprintf(FINFO, "S;;;STATS;;;TTS;;;%lld;;;FC;;;%d\n", tts, stats.num_transferred_files);
+		}
+	}
+#endif
 }
 
 
@@ -373,9 +409,11 @@
 	} else {
 		OFF_T j;
 		/* by doing this in pieces we avoid too many seeks */
-		for (j = last_match + CHUNK_SIZE; j < len; j += CHUNK_SIZE)
+		// BOMBICH: I added the buf->status == 0 conditions so rsync will bail more quickly on read errors
+		for (j = last_match + CHUNK_SIZE; j < len && buf->status == 0; j += CHUNK_SIZE)
 			matched(f, s, buf, j, -2);
-		matched(f, s, buf, len, -1);
+		if (len == 0 || (buf && buf->status == 0))
+			matched(f, s, buf, len, -1);
 	}
 
 	if (sum_end(sender_file_sum) != checksum_len)
diff -Naur -X diff_ignore rsync-3.0.6_base/options.c rsync/options.c
--- rsync-3.0.6_base/options.c	2010-10-25 14:18:07.000000000 -0400
+++ rsync/options.c	2018-11-15 21:22:44.000000000 -0500
@@ -21,7 +21,7 @@
 
 #include "rsync.h"
 #include "ifuncs.h"
-#include <popt.h>
+#include "popt.h"
 #include "zlib/zlib.h"
 
 extern int module_id;
@@ -43,8 +43,10 @@
  * @sa disable_deltas_p()
  **/
 int whole_file = -1;
-
+float write_size_multiplier = 1.0;
+int io_buf_size = IO_BUFFER_SIZE;
 int append_mode = 0;
+int detect_case_conflicts = 0;
 int keep_dirlinks = 0;
 int copy_dirlinks = 0;
 int copy_links = 0;
@@ -52,6 +54,13 @@
 int preserve_hard_links = 0;
 int preserve_acls = 0;
 int preserve_xattrs = 0;
+int preserve_hfs_compression = 0;
+int replace_dirs_with_diff_type = 0;
+int delete_modified = 0;
+int delete_deleted = 0;
+uid_t dest_file_owner = 0;
+uid_t sender_uid = 0;
+uid_t receiver_uid = 0;
 int preserve_perms = 0;
 int preserve_fileflags = 0;
 int preserve_executability = 0;
@@ -119,6 +128,7 @@
 int max_delete = INT_MIN;
 OFF_T max_size = 0;
 OFF_T min_size = 0;
+time_t max_age = 0;
 int ignore_errors = 0;
 int modify_window = 0;
 int blocking_io = -1;
@@ -192,6 +202,7 @@
 int logfile_format_has_i = 0;
 int logfile_format_has_o_or_i = 0;
 int always_checksum = 0;
+int dont_csum_data_buffer = 0;
 int list_only = 0;
 
 #define MAX_BATCH_NAME_LEN 256	/* Must be less than MAXPATHLEN-13 */
@@ -214,6 +225,7 @@
 static int refused_delete_during;
 static int refused_inplace, refused_no_iconv;
 static char *max_size_arg, *min_size_arg;
+static char *max_age_arg;
 static char tmp_partialdir[] = ".~tmp~";
 
 /** Local address to bind.  As a character string because it's
@@ -331,6 +343,7 @@
   rprintf(F," -q, --quiet                 suppress non-error messages\n");
   rprintf(F,"     --no-motd               suppress daemon-mode MOTD (see manpage caveat)\n");
   rprintf(F," -c, --checksum              skip based on checksum, not mod-time & size\n");
+  rprintf(F,"     --no-csum-data-buf      Don't verify that data written into RAM matches when read back out\n");
   rprintf(F," -a, --archive               archive mode; equals -rlptgoD (no -H,-A,-X)\n");
   rprintf(F,"     --no-OPTION             turn off an implied OPTION (e.g. --no-D)\n");
   rprintf(F," -r, --recursive             recurse into directories\n");
@@ -365,6 +378,11 @@
 #ifdef SUPPORT_XATTRS
   rprintf(F," -X, --xattrs                preserve extended attributes\n");
 #endif
+#ifdef SUPPORT_HFS_COMPRESSION
+  rprintf(F,"     --hfs-compression       preserve HFS compression (if source & destination support it)\n");
+  rprintf(F,"     --protect-decmpfs       preserve HFS compression (regardless of volume support)\n");
+#endif
+  rprintf(F,"     --replace-dirs          replace folders with items of a different type (regardless of --delete*)\n");
   rprintf(F," -o, --owner                 preserve owner (super-user only)\n");
   rprintf(F," -g, --group                 preserve group\n");
   rprintf(F,"     --devices               preserve device files (super-user only)\n");
@@ -380,6 +398,7 @@
   rprintf(F," -S, --sparse                handle sparse files efficiently\n");
   rprintf(F," -n, --dry-run               perform a trial run with no changes made\n");
   rprintf(F," -W, --whole-file            copy files whole (without delta-xfer algorithm)\n");
+  rprintf(F," -w, --write-size-mult=SIZE  Write size = dest.f_iosize * multiplier\n");
   rprintf(F," -x, --one-file-system       don't cross filesystem boundaries\n");
   rprintf(F," -B, --block-size=SIZE       force a fixed checksum block-size\n");
   rprintf(F," -e, --rsh=COMMAND           specify the remote shell to use\n");
@@ -470,9 +489,9 @@
 enum {OPT_VERSION = 1000, OPT_DAEMON, OPT_SENDER, OPT_EXCLUDE, OPT_EXCLUDE_FROM,
       OPT_FILTER, OPT_COMPARE_DEST, OPT_COPY_DEST, OPT_LINK_DEST, OPT_HELP,
       OPT_INCLUDE, OPT_INCLUDE_FROM, OPT_MODIFY_WINDOW, OPT_MIN_SIZE, OPT_CHMOD,
-      OPT_READ_BATCH, OPT_WRITE_BATCH, OPT_ONLY_WRITE_BATCH, OPT_MAX_SIZE,
+      OPT_READ_BATCH, OPT_WRITE_BATCH, OPT_ONLY_WRITE_BATCH, OPT_MAX_SIZE, 
       OPT_NO_D, OPT_APPEND, OPT_NO_ICONV,
-      OPT_SERVER, OPT_REFUSED_BASE = 9000};
+      OPT_SERVER, OPT_MAX_AGE, OPT_REFUSED_BASE = 9000};
 
 static struct poptOption long_options[] = {
   /* longName, shortName, argInfo, argPtr, value, descrip, argDesc */
@@ -571,6 +590,7 @@
   {"ignore-existing",  0,  POPT_ARG_NONE,   &ignore_existing, 0, 0, 0 },
   {"max-size",         0,  POPT_ARG_STRING, &max_size_arg, OPT_MAX_SIZE, 0, 0 },
   {"min-size",         0,  POPT_ARG_STRING, &min_size_arg, OPT_MIN_SIZE, 0, 0 },
+  {"max-age",          0,  POPT_ARG_STRING, &max_age_arg, OPT_MAX_AGE, 0, 0 },
   {"sparse",          'S', POPT_ARG_VAL,    &sparse_files, 1, 0, 0 },
   {"no-sparse",        0,  POPT_ARG_VAL,    &sparse_files, 0, 0, 0 },
   {"no-S",             0,  POPT_ARG_VAL,    &sparse_files, 0, 0, 0 },
@@ -586,8 +606,8 @@
   {"delete-delay",     0,  POPT_ARG_VAL,    &delete_during, 2, 0, 0 },
   {"delete-after",     0,  POPT_ARG_NONE,   &delete_after, 0, 0, 0 },
   {"delete-excluded",  0,  POPT_ARG_NONE,   &delete_excluded, 0, 0, 0 },
-  {"remove-sent-files",0,  POPT_ARG_VAL,    &remove_source_files, 2, 0, 0 }, /* deprecated */
-  {"remove-source-files",0,POPT_ARG_VAL,    &remove_source_files, 1, 0, 0 },
+//  {"remove-sent-files",0,  POPT_ARG_VAL,    &remove_source_files, 2, 0, 0 }, /* deprecated */
+//  {"remove-source-files",0,POPT_ARG_VAL,    &remove_source_files, 1, 0, 0 },
   {"force",            0,  POPT_ARG_VAL,    &force_delete, 1, 0, 0 },
   {"no-force",         0,  POPT_ARG_VAL,    &force_delete, 0, 0, 0 },
   {"force-delete",     0,  POPT_ARG_VAL,    &force_delete, 1, 0, 0 },
@@ -598,6 +618,18 @@
   {"force-uchange",    0,  POPT_ARG_VAL,    &force_change, USR_IMMUTABLE, 0, 0 },
   {"force-schange",    0,  POPT_ARG_VAL,    &force_change, SYS_IMMUTABLE, 0, 0 },
 #endif
+#ifdef SUPPORT_HFS_COMPRESSION
+  {"hfs-compression",  0,  POPT_ARG_VAL,    &preserve_hfs_compression, 1, 0, 0 },
+  {"protect-decmpfs",  0,  POPT_ARG_VAL,    &preserve_hfs_compression, 2, 0, 0 },
+  {"no-hfs-compression",0, POPT_ARG_VAL,    &preserve_hfs_compression, 0, 0, 0 },
+  {"no-protect-decmpfs",0, POPT_ARG_VAL,    &preserve_hfs_compression, 0, 0, 0 },
+#endif
+  {"replace-dirs",     0,  POPT_ARG_VAL,    &replace_dirs_with_diff_type, 1, 0, 0 },
+  {"delete-modified",  0,  POPT_ARG_VAL,    &delete_modified, 1, 0, 0 },
+  {"delete-deleted",   0,  POPT_ARG_VAL,    &delete_deleted, 1, 0, 0 },
+  {"dest-file-owner",  0,  POPT_ARG_INT,    &dest_file_owner, 0, 0, 0 },
+  {"sender-uid",	   0,  POPT_ARG_INT,    &sender_uid, 0, 0, 0 },
+  {"receiver-uid",	   0,  POPT_ARG_INT,    &receiver_uid, 0, 0, 0 },
   {"ignore-errors",    0,  POPT_ARG_VAL,    &ignore_errors, 1, 0, 0 },
   {"no-ignore-errors", 0,  POPT_ARG_VAL,    &ignore_errors, 0, 0, 0 },
   {"max-delete",       0,  POPT_ARG_INT,    &max_delete, 0, 0, 0 },
@@ -611,9 +643,14 @@
   {"whole-file",      'W', POPT_ARG_VAL,    &whole_file, 1, 0, 0 },
   {"no-whole-file",    0,  POPT_ARG_VAL,    &whole_file, 0, 0, 0 },
   {"no-W",             0,  POPT_ARG_VAL,    &whole_file, 0, 0, 0 },
+  {"write-size-mult", 'w', POPT_ARG_FLOAT,	&write_size_multiplier, 0, 0, 0 },
+  {"io-buf-size",	   0,  POPT_ARG_INT,	&io_buf_size, 0, 0, 0 },
+  {"case-conflicts",   0,  POPT_ARG_VAL,	&detect_case_conflicts, 1, 0, 0 },
+  {"no-case-conflicts",0,  POPT_ARG_VAL,	&detect_case_conflicts, 0, 0, 0 },
   {"checksum",        'c', POPT_ARG_VAL,    &always_checksum, 1, 0, 0 },
   {"no-checksum",      0,  POPT_ARG_VAL,    &always_checksum, 0, 0, 0 },
   {"no-c",             0,  POPT_ARG_VAL,    &always_checksum, 0, 0, 0 },
+  {"no-csum-data-buf", 0,  POPT_ARG_VAL,	&dont_csum_data_buffer, 1, 0, 0 },
   {"block-size",      'B', POPT_ARG_LONG,   &block_size, 0, 0, 0 },
   {"compare-dest",     0,  POPT_ARG_STRING, 0, OPT_COMPARE_DEST, 0, 0 },
   {"copy-dest",        0,  POPT_ARG_STRING, 0, OPT_COPY_DEST, 0, 0 },
@@ -1221,6 +1258,16 @@
 			}
 			break;
 
+		case OPT_MAX_AGE:
+			errno = 0;
+			if ((max_age = (time_t)strtoull(max_age_arg, NULL, 10)) <= 0 || errno == ERANGE) {
+				snprintf(err_buf, sizeof err_buf,
+					"--max-age value is invalid: %s\n",
+					max_age_arg);
+				return 0;
+			}
+			break;
+
 		case OPT_APPEND:
 			if (am_server)
 				append_mode++;
@@ -1374,6 +1421,30 @@
 	}
 #endif
 
+#ifdef SUPPORT_HFS_COMPRESSION
+	if (preserve_hfs_compression > 0) {
+		if (preserve_xattrs == 0)
+			preserve_xattrs++;
+		if (preserve_fileflags == 0)
+			preserve_fileflags++;
+	}
+#else
+	snprintf(err_buf,sizeof(err_buf),
+		 "HFS compression is not supported on this %s\n",
+		 am_server ? "server" : "client");
+	preserve_hfs_compression = 0;
+#endif
+
+	if (dont_csum_data_buffer) {
+		if (always_checksum) {
+			snprintf(err_buf, sizeof err_buf,
+					 "--no-csum-data-buf and --checksum can not be used together\n");
+			dont_csum_data_buffer = 0;
+		} else {
+			fprintf(stderr, "DEBUG: Copy buffer will not be checksummed\n");
+		}
+	}
+	
 	if (write_batch && read_batch) {
 		snprintf(err_buf, sizeof err_buf,
 			"--write-batch and --read-batch can not be used together\n");
@@ -1598,7 +1669,7 @@
 		backup_dir_dels = backup_dir;
 		backup_dir_dels_len = backup_dir_len;
 		backup_dir_dels_remainder = backup_dir_remainder;
-		strlcpy(backup_dir_dels_buf, backup_dir_buf, sizeof backup_dir_buf);
+		strlcpy(backup_dir_dels_buf, backup_dir_buf, sizeof(backup_dir_dels_buf));
 	} else if (!backup_suffix_dels_len && (!am_server || !am_sender)) {
 		snprintf(err_buf, sizeof err_buf,
 			"--suffix-dels cannot be a null string without --backup-dir-dels\n");
@@ -1973,6 +2044,57 @@
 	if (preserve_fileflags)
 		args[ac++] = "--fileflags";
 
+#ifdef SUPPORT_HFS_COMPRESSION
+	if (preserve_hfs_compression == 1)
+		args[ac++] = "--hfs-compression";
+	else if (preserve_hfs_compression == 2)
+		args[ac++] = "--protect-decmpfs";
+#endif
+	if (replace_dirs_with_diff_type > 0)
+		args[ac++] = "--replace-dirs";
+		
+	if (delete_modified > 0)
+		args[ac++] = "--delete-modified";
+
+	if (delete_deleted > 0)
+		args[ac++] = "--delete-deleted";
+
+	if (dest_file_owner > 0) {
+		if (asprintf(&arg, "--dest-file-owner=%d", dest_file_owner) < 0)
+			goto oom;
+		args[ac++] = arg;
+	}
+	
+	if (sender_uid > 0) {
+		if (asprintf(&arg, "--sender-uid=%d", sender_uid) < 0)
+			goto oom;
+		args[ac++] = arg;
+	}
+	
+	if (receiver_uid > 0) {
+		if (asprintf(&arg, "--receiver-uid=%d", receiver_uid) < 0)
+			goto oom;
+		args[ac++] = arg;
+	}
+	
+	if (dont_csum_data_buffer > 0)
+		args[ac++] = "--no-csum-data-buf";
+	
+	if (write_size_multiplier != 1.0) {
+		if (asprintf(&arg, "-w%.2f", write_size_multiplier) < 0)
+			goto oom;
+		args[ac++] = arg;
+	}
+	
+	if (io_buf_size != IO_BUFFER_SIZE) {
+		if (asprintf(&arg, "--io-buf-size=%d", io_buf_size) < 0)
+			goto oom;
+		args[ac++] = arg;
+	}
+	
+	if (detect_case_conflicts != 0)
+		args[ac++] = "--case-conflicts";
+	
 	if (do_compression && def_compress_level != Z_DEFAULT_COMPRESSION) {
 		if (asprintf(&arg, "--compress-level=%d", def_compress_level) < 0)
 			goto oom;
@@ -2042,6 +2164,22 @@
 			goto oom;
 		args[ac++] = arg;
 	}
+
+	// The following options were previously inside of the (am_sender)
+	// block, but we need to send these options to a remote source as 
+	// client/receiver
+	if (max_age) {
+		args[ac++] = "--max-age";
+		args[ac++] = max_age_arg;
+	}
+	if (min_size) {
+		args[ac++] = "--min-size";
+		args[ac++] = min_size_arg;
+	}
+	if (max_size) {
+		args[ac++] = "--max-size";
+		args[ac++] = max_size_arg;
+	}
 	if (am_sender) {
 		if (max_delete > 0) {
 			if (asprintf(&arg, "--max-delete=%d", max_delete) < 0)
@@ -2049,14 +2187,6 @@
 			args[ac++] = arg;
 		} else if (max_delete == 0)
 			args[ac++] = "--max-delete=-1";
-		if (min_size) {
-			args[ac++] = "--min-size";
-			args[ac++] = min_size_arg;
-		}
-		if (max_size) {
-			args[ac++] = "--max-size";
-			args[ac++] = max_size_arg;
-		}
 		if (delete_before)
 			args[ac++] = "--delete-before";
 		else if (delete_during == 2)
diff -Naur -X diff_ignore rsync-3.0.6_base/proto.h rsync/proto.h
--- rsync-3.0.6_base/proto.h	2009-06-18 17:30:50.000000000 -0400
+++ rsync/proto.h	2018-10-13 16:17:50.000000000 -0400
@@ -59,6 +59,8 @@
 int daemon_main(void);
 void set_allow_inc_recurse(void);
 void setup_protocol(int f_out,int f_in);
+void do_filesystem_compatibility_checks(const char *path);
+int filesystem_capabilities(const char *path, struct statfs *sfs, u_int32_t *capability_fmt, u_int32_t *capability_int);
 int claim_connection(char *fname, int max_connections);
 void set_filter_dir(const char *dir, unsigned int dirlen);
 void *push_local_filters(const char *dir, unsigned int dirlen);
@@ -106,6 +108,7 @@
 void itemize(const char *fnamecmp, struct file_struct *file, int ndx, int statret,
 	     stat_x *sxp, int32 iflags, uchar fnamecmp_type,
 	     const char *xname);
+char * printableChecksum(char *sum);
 int unchanged_file(char *fn, struct file_struct *file, STRUCT_STAT *st);
 void check_for_finished_files(int itemizing, enum logcode code, int check_redo);
 void generate_files(int f_out, const char *local_name);
@@ -240,6 +243,7 @@
 void maybe_log_item(struct file_struct *file, int iflags, int itemizing,
 		    const char *buf);
 void log_delete(const char *fname, int mode);
+void log_non_transfer(const char *fname, int mode, int iflags);
 void log_exit(int code, const char *file, int line);
 pid_t wait_process(pid_t pid, int *status_ptr, int flags);
 int child_main(int argc, char *argv[]);
@@ -318,7 +322,7 @@
 time_t get_create_time(const char *path);
 int set_create_time(const char *path, time_t crtime);
 void set_compression(const char *fname);
-void send_token(int f, int32 token, struct map_struct *buf, OFF_T offset,
+void send_token(int f, int32 token, struct map_struct *buf, OFF_T offset, 
 		int32 n, int32 toklen);
 int32 recv_token(int f, char **data);
 void see_token(char *data, int32 toklen);
@@ -330,6 +334,7 @@
 uid_t recv_user_name(int f, uid_t uid);
 gid_t recv_group_name(int f, gid_t gid, uint16 *flags_ptr);
 void recv_id_list(int f, struct file_list *flist);
+void heartbeat(char *fbuf);
 void set_nonblocking(int fd);
 void set_blocking(int fd);
 int fd_pair(int fd[2]);
@@ -342,6 +347,7 @@
 int full_write(int desc, const char *ptr, size_t len);
 int copy_file(const char *source, const char *dest, int ofd,
 	      mode_t mode, int create_bak_dir);
+int copy_sparse_file(const char *src, const char *dst, mode_t mode, off_t logicalSize, off_t physicalSize, int sparse_files);
 int robust_unlink(const char *fname);
 int robust_rename(const char *from, const char *to, const char *partialptr,
 		  int mode);
